/*
    A random number generator compatible with J2ME
    Copyright (C) 2003 Irene Cummings (i.n.c@ezrs.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package inc;

import java.util.*;

//class to return random numbers in a range 0-size
public class RadNo
{
	static Random myRand=new Random(new Date().getTime());
	private long m_SectSize;
	private int m_MaxRangedRand;

	public RadNo(int noChoices)
	{
		//max random no must be whole number of
		//sectionSizes (or last element will have
		//a better chance!)
		m_SectSize=2147483647/noChoices;
		m_MaxRangedRand=(int)m_SectSize*noChoices;
	}

	public int nextInt()
	{
		//doesnt round, truncates!

		int randomNo=(int)m_MaxRangedRand+1;
		while (randomNo>m_MaxRangedRand)
		{
			randomNo=myRand.nextInt();
			//can not seem to find mx lib!!!
			if (randomNo<0) randomNo=-randomNo;
		}

		long rangedRand=randomNo/m_SectSize;

		return (int)rangedRand;
	}
}
