/*
    A sorted vector compatible with J2ME
    Copyright (C) 2003 Irene Cummings (i.n.c@ezrs.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package inc;

import java.util.Vector;

public class SortedVector extends Vector
{
	public SortedVector()
	{
		//noop
	}

	public void addElement(Comparable cmp)
	{
		this.addElement(cmp,true);
	}

	//if element considered to be "equal" to current one should it be added?
	public boolean addElement(Comparable cmp, boolean allowDuplicates)
	{
		boolean needsInsertion=true;
		boolean inserted=false;
		for (int i=0;i<this.size();i++)
		{
			int sortValue=((Comparable)this.elementAt(i)).compare(cmp);
			if (sortValue<0)
			{
				//add to end (if equal to end of chain of same)
				super.insertElementAt(cmp,i);
				needsInsertion=false;
				inserted=true;
				break;
			}
			else if (sortValue==0)
			{
				needsInsertion=false;
				break;
			}
		}
		if (needsInsertion==true)
		{
			super.addElement(cmp);
			inserted=true;
		}
		return inserted;
	}

	//disallow baseclass insertions as fucks up sorting
	public void addElement(Object obj)
	{
		//noop
	}

	public void insertElementAt(Object obj, int index)
	{
		//noop
	}

	public void setElementAt(Object obj, int index) 
	{
		//noop
	}

}
